[BACK]Return to update_openbsd CVS log [TXT][DIR] Up to [local] / openbsd / update_openbsd

Diff for /openbsd/update_openbsd/update_openbsd between version 1.70 and 1.118

version 1.70, 2015/01/18 02:59:23 version 1.118, 2018/12/16 21:10:00
Line 1 
Line 1 
 #!/bin/sh  #!/bin/sh
 # $AFresh1: update_openbsd,v 1.69 2014/10/18 23:05:49 andrew Exp $  # $AFresh1: update_openbsd,v 1.117 2018/12/16 20:57:49 andrew Exp $
 #  #
 # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>  # Copyright (c) 2012 Andrew Fresh <andrew@afresh1.com>
 #  #
 # Permission to use, copy, modify, and distribute this software for any  # Permission to use, copy, modify, and distribute this software for any
Line 27 
Line 27 
     local xserv=/usr/X11R6/bin/X      local xserv=/usr/X11R6/bin/X
     local xshare=/usr/X11R6/bin/startx      local xshare=/usr/X11R6/bin/startx
   
       local _nv=`echo $NEW_VER | sed -e 's/\.//'`
     local _c _d _e      local _c _d _e
     echo -n base      echo -n base
     echo -n ' etc'      [ $_nv -lt 57 ] && echo -n ' etc'
     for _d in misc man comp game xbase xetc xfont xserv xshare; do      for _d in misc man comp game xbase xetc xfont xserv xshare; do
           [ $_d = xetc -a $_nv -ge 57 ] && continue
         eval _e=\$${_d}          eval _e=\$${_d}
         _c=`ls $_e 2> /dev/null | wc -l`          _c=`ls $_e 2> /dev/null | wc -l`
         #echo $_c $_d $_e          #echo $_c $_d $_e
Line 40 
Line 42 
     done      done
   
     sendmail -d0.1 --badoption </dev/null 2>/dev/null | grep -q SASL      sendmail -d0.1 --badoption </dev/null 2>/dev/null | grep -q SASL
     if [ $? == 0 ]; then      if [ $? == 0 ]; then
         echo -n ' sendmail-smtp_auth'          echo -n ' sendmail-smtp_auth'
     fi      fi
 }  }
Line 50 
Line 52 
     #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'      #what $1 | sed -ne 's/[[:blank:]]\{1,\}//p'
 }  }
   
   kernel_is_multiprocessor() {
       printf "find cpu*\nexit\n" | config -e $1 2>/dev/null | grep -q "cpu\* at "
   }
   
 version_in() {  version_in() {
         local _proto=${FTP%%://*}          local _proto=${FTP%%://*}
         local _file          local _file
Line 58 
Line 64 
             local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`              local _list=`echo "ls base*.tgz" | ${FTP_CMD} ${FTP}/`
             _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`              _file=`echo ${_list} | awk '/base[0-9][0-9].tgz/ { print $9 }'`
   
         elif [ X"http" == X"${_proto}" ]; then          elif [ X"http" == X"${_proto}" -o X"https" == X"${_proto}" ]; then
             local _list=`${FTP_CMD} -V -o - ${FTP}/`              _file=`${FTP_CMD} -V -o - ${FTP}/index.txt |
             _file=`echo ${_list} | awk '/[^x]base[0-9][0-9]*\.tgz/ {                  sed -ne 's/.*\(base[0-9][0-9].tgz\).*/\1/p'`
                     sub("^.*base","base");  
                     sub("\.tgz.*",".tgz");  
                     print $0;  
                 }'`  
   
         elif [ X"scp" == X"${_proto}" ]; then          elif [ X"scp" == X"${_proto}" ]; then
             echo SCP is not yet supported >&2              echo SCP is not yet supported >&2
             return 2              return 2
   
         else          else
             echo Unsupported FTP ${FTP} >&2              echo Unsupported FTP ${FTP} >&2
             return 2              return 2
   
Line 81 
Line 83 
         echo $_v          echo $_v
 }  }
   
   set_boot_device() {
           BOOT_DEVICE=$( df -lnP /bsd | sed -ne 's! .*/$!!p' )
   
           root_disk=$( echo $BOOT_DEVICE |
               sed -e 's,/dev/\([a-z]*[0-9]\)[a-z].*,\1,' )
           msdos_partition=$(
               fdisk $root_disk | grep -q '^*.*FAT32' \
               && \
               disklabel $root_disk | sed -ne 's/:.*MSDOS//p' | tr -d ' '
           )
   
           [ "$msdos_partition" ] &&
               BOOT_DEVICE="/dev/$root_disk$msdos_partition"
   }
   
   boot_device_mounted=""
   mount_boot_device() {
       [ "$boot_device_mounted" ] && return
       [ "$BOOT_DEVICE" ] || return
   
       local boot_mount=$( mount |
               sed -ne "s!^$BOOT_DEVICE on \([^ ]*\).*!\1!p" )
   
       if [ ! "$boot_mount" ]; then
           mount $BOOT_DEVICE /mnt
           boot_device_mounted=1
       fi
   }
   
   umount_boot_device() {
       [ "$boot_device_mounted" ] && umount $BOOT_DEVICE
       boot_device_mounted=""
   }
   
   find_boot_kernel() {
       local _k=$( ( \
           echo bsd; \
           [ -e boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \
               s///; s/^.*://; s/ .*$//' boot.conf \
       ) | tail -1 )
       _k=$( follow_symlink $_k )
   
       local _d=$( dirname $_k )
       [ "$_d" = "." ] && _d=$PWD
   
       if [ $_d = . -o $_d = $PWD ]; then
           basename $_k
       else
           echo $_k
       fi
   }
   
 set_version() {  set_version() {
     CUR_VER=`uname -r`      CUR_VER=`uname -r`
     NEW_VER=`dc -e "$CUR_VER 0.1 + p"`      NEW_VER=`dc -e "$CUR_VER 0.1 + p"`
Line 89 
Line 143 
   
     local _cv=`echo $CUR_VER | sed -e 's/\.//'`      local _cv=`echo $CUR_VER | sed -e 's/\.//'`
     local _nv=`echo $NEW_VER | sed -e 's/\.//'`      local _nv=`echo $NEW_VER | sed -e 's/\.//'`
     local _v      local _v _d _pkr
   
     if [ X"No" != X"$FORCE_DIR" -a -d $FORCE_DIR ]; then      if [ X"No" != X"$FORCE_DIR" -a -d $FORCE_DIR ]; then
         _dir=$FORCE_DIR          _dir=$FORCE_DIR
Line 116 
Line 170 
     fi      fi
   
     if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then      if [ X"" != X"${MIRROR}" -a X"" == X"${_v}" ]; then
         if [ X"No" == X"${FORCE_DIR}" ]; then          if [ X"No" != X"${FORCE_DIR}" ]; then
             _dir=${NEW_VER}  
         else  
             _dir=${FORCE_DIR}              _dir=${FORCE_DIR}
           elif sysctl kern.version | grep -q -- '-current '; then
               _dir=snapshots
               FORCE_DIR=snapshots
           else
               _dir=${NEW_VER}
         fi          fi
         FTP=${MIRROR}/${_dir}/`machine`          FTP=${MIRROR}/${_dir}/`machine`
   
Line 140 
Line 197 
   
         if [ X"" == X"${_v}" ]; then          if [ X"" == X"${_v}" ]; then
             echo No sets in [${FTP}] >&2              echo No sets in [${FTP}] >&2
             return 2              return 2
         elif [ X"${_cv}" == X"${_v}" ]; then          elif [ X"${_cv}" == X"${_v}" ]; then
             NEW_VER=$CUR_VER              NEW_VER=$CUR_VER
         elif [ X"${_nv}" == X"${_v}" ]; then          elif [ X"${_nv}" == X"${_v}" ]; then
Line 174 
Line 231 
         FTP=${MIRROR}/${_dir}/`machine`          FTP=${MIRROR}/${_dir}/`machine`
     fi      fi
   
     BOOT_KERNEL=`( \      KERNEL_ROOT=""
         echo bsd; \      [ -z "$BOOT_DEVICE" ] && set_boot_device
         [ -e /boot.conf ] && sed -E '/^ *(set +image|boot) +/!d ; \  
             s///; s/^.*://; s/ .*$//' /boot.conf \  
     ) | tail -1`  
     BOOT_KERNEL=`follow_symlink /$BOOT_KERNEL`  
     BOOT_KERNEL="/${BOOT_KERNEL#/}"  
   
     BOOT_KERNEL_VERSION=`kernel_file_version $BOOT_KERNEL`      mount_boot_device
   
       # _pkr == possible_kernel_roots
       _pkr=/
       [ "$BOOT_DEVICE" ] && _pkr="/mnt/ $_pkr"
   
       for _d in $_pkr; do
           KERNEL_ROOT=$( df -lnP ${_d}bsd 2>/dev/null | sed -ne 's!/dev/.* !!p' )
           [ "$KERNEL_ROOT" ] && break
       done
   
       if ! [ "$KERNEL_ROOT" ]; then
           echo "Unable to find KERNEL_ROOT, tried $_pkr" >&2
           exit 2
       fi
   
       cd $KERNEL_ROOT
       BOOTED_KERNEL=$( find_boot_kernel )
       BOOT_KERNEL_VERSION=$( kernel_file_version $BOOTED_KERNEL )
   
       if [ $(sysctl -n hw.ncpufound) -gt 1 ] || kernel_is_multiprocessor $BOOTED_KERNEL; then
           BOOT_KERNEL=bsd.mp
       else
           BOOT_KERNEL=$BOOTED_KERNEL
       fi
   
     BOOTED_KERNEL_VERSION=`sysctl -n kern.version`      BOOTED_KERNEL_VERSION=`sysctl -n kern.version`
     NEW_KERNEL_VERSION=""      NEW_KERNEL_VERSION=""
   
     # We want to default to what we had      # We want to default to what we had
     INSTALL_KERNELS="${BOOT_KERNEL#/}"      INSTALL_KERNELS="$BOOT_KERNEL"
     # if the boot kernel was our specially named bsd.sp, we install from bsd      # if the boot kernel was our specially named bsd.sp, we install from bsd
     if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then      if [ X"$INSTALL_KERNELS" == X"bsd.sp" ]; then
         INSTALL_KERNELS="bsd"          INSTALL_KERNELS="bsd"
     fi      fi
     # with a second option of an mp kernel if is is a likely candidate  
     if [ X"$INSTALL_KERNELS" != X"bsd.mp" ]; then      # We want to update all kernels that exist
         local _ncpu=$(sysctl -n hw.ncpufound)      # either in the $KERNEL_ROOT or in /
         [ $_ncpu -gt 1 ] && INSTALL_KERNELS="$INSTALL_KERNELS bsd.mp"      for b in bsd bsd.mp; do
           [ -e $b -o -e /$b ] || continue
           if [ X"${INSTALL_KERNELS% *}" != X"$b" ]; then
               INSTALL_KERNELS="$INSTALL_KERNELS $b"
           fi
       done
   
       cd $OLDPWD
   
       EFI_BOOT=""
       if [ -d "/mnt/efi/boot" ]; then
           _d=$( cd "/mnt/efi/boot" && ls -1 *.{efi,EFI} 2>/dev/null )
           # assume an MSDOS filesystem and so case insensitive
           [ "$_d" ] && EFI_BOOT=$( echo $_d | tr a-z A-Z )
     fi      fi
     # or just bsd otherwise  
     if [ X"${INSTALL_KERNELS% *}" != X"bsd" ]; then      umount_boot_device
         INSTALL_KERNELS="$INSTALL_KERNELS bsd"  
     fi  
     BOOT_KERNELS=$INSTALL_KERNELS      BOOT_KERNELS=$INSTALL_KERNELS
     INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"      INSTALL_KERNELS="$INSTALL_KERNELS bsd.rd"
 }  }
Line 218 
Line 306 
   
     local _v=$FILE_VER      local _v=$FILE_VER
   
       if [ "$EFI_BOOT" ]; then
           _b="$EFI_BOOT"
           if [ ! -e ./${_b} ]; then
               echo "===> $FTP_CMD ${FTP}/${_b}"
               $FTP_CMD ${FTP}/${_b}
           else
               echo "===> Have ${_b}"
           fi
       fi
   
     for _b in $INSTALL_KERNELS; do      for _b in $INSTALL_KERNELS; do
         if [ ! -e ./${_b} ]; then          if [ ! -e ./${_b} ]; then
             echo "===> $FTP_CMD ${FTP}/${_b}"              echo "===> $FTP_CMD ${FTP}/${_b}"
Line 229 
Line 327 
     done      done
   
     for _s in $INSTALLED_SETS; do      for _s in $INSTALLED_SETS; do
           [ "$_v" -ge "57" -a "$_s" != "${_s%etc}" ] && continue
         local _file=${_s}${_v}.tgz          local _file=${_s}${_v}.tgz
         if [ ${_s} == sendmail-smtp_auth ]; then          if [ ${_s} == sendmail-smtp_auth ]; then
             _file=${_s}.gz              _file=${_s}.gz
Line 254 
Line 353 
     local _file=$1      local _file=$1
     # This could go circular, but I dunno how to fix that.      # This could go circular, but I dunno how to fix that.
     if [ -h $_file ]; then      if [ -h $_file ]; then
         follow_symlink $( file $_file |          follow_symlink $( readlink -f $_file )
             grep 'symbolic link' |  
             sed -e s/^.*\\\`// -e s/\\\'\$// )  
     else      else
         echo $_file          echo $_file
     fi      fi
Line 274 
Line 371 
   
     local _nv=`echo $NEW_VER | sed -e 's/\.//'`      local _nv=`echo $NEW_VER | sed -e 's/\.//'`
     local _signify=`which signify 2>/dev/null`      local _signify=`which signify 2>/dev/null`
     local _keyfile=/etc/signify/openbsd-${_nv}-base.pub      local _keyfile=/etc/signify/openbsd-${_nv}-base.pub
     local _b _s      local _b _s
   
     (      (
         for _b in $INSTALL_KERNELS; do echo "($_b)"        ; done          for _b in $INSTALL_KERNELS; do echo "($_b)"        ; done
         for _s in $INSTALLED_SETS;  do echo "($_s$_nv.tgz)"; done          for _s in $INSTALLED_SETS;  do echo "($_s$_nv.tgz)"; done
     ) > index      ) > index
   
   
   
     if [ -n "$_signify" -a "$_type" != "${_type%.sig}" ]; then      if [ -n "$_signify" -a "$_type" != "${_type%.sig}" ]; then
         echo "===> Checking signature";          echo "===> Checking signature";
         if [ ! -e $_keyfile ]; then          if [ ! -e $_keyfile ]; then
Line 291 
Line 388 
         fi          fi
         signify -V -e -p $_keyfile -x $_type -m - | grep -f index | sha256 -c -          signify -V -e -p $_keyfile -x $_type -m - | grep -f index | sha256 -c -
     else      else
        grep -f index $_type | sum -c         grep -f index $_type | sha256 -c
     fi      fi
   
     if [ $? -ne 0 ]; then      if [ $? -ne 0 ]; then
Line 307 
Line 404 
     local _missing_sets      local _missing_sets
     local _v=$FILE_VER      local _v=$FILE_VER
   
       mount_boot_device
     for _n in $INSTALL_KERNELS; do      for _n in $INSTALL_KERNELS; do
         local _o=$_n          local _o=$_n
         [ X"bsd" == X"${_o}" -a -e /bsd.sp ] && _o=bsd.sp          [ X"bsd" == X"${_o}" -a -e ${KERNEL_ROOT}bsd.sp ] && _o=bsd.sp
         if [ -e /${_o} -a ! -e ./${_n} ]; then          if [ -e ${KERNEL_ROOT}${_o} -a ! -e ./${_n} ]; then
             echo ${_o} does not exist              echo ${_o} does not exist on $BOOT_DEVICE
             _missing_sets=1              _missing_sets=1
         fi          fi
   
         if [ X"${BOOT_KERNEL}" == X"/${_o}" -a -e ./${_n} ]; then          if [ X"${BOOT_KERNEL}" == X"${_o}" -a -e ./${_n} ]; then
             NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`              NEW_KERNEL_VERSION=`kernel_file_version ./${_n}`
         fi          fi
     done      done
       umount_boot_device
   
     if [ X"$NEW_KERNEL_VERSION" == X"" ]; then      if [ X"$NEW_KERNEL_VERSION" == X"" ]; then
         echo Missing replacement for boot kernel $BOOT_KERNEL >&2          echo Missing replacement for boot kernel $BOOT_KERNEL >&2
Line 326 
Line 425 
     fi      fi
   
     for _s in $INSTALLED_SETS; do      for _s in $INSTALLED_SETS; do
           [ "$_v" -ge "57" -a "$_s" != "${_s%etc}" ] && continue
         local _file=${_s}${_v}.tgz          local _file=${_s}${_v}.tgz
         if [ ${_s} == sendmail-smtp_auth ]; then          if [ ${_s} == sendmail-smtp_auth ]; then
             _file=${_s}.gz              _file=${_s}.gz
Line 337 
Line 437 
     done      done
   
     if [ X"" == X"${_missing_sets}" ]; then      if [ X"" == X"${_missing_sets}" ]; then
         echo '===> All OK'          echo 'All OK'
     fi      fi
   
     local _type      local _type
     for _type in $CHECKSUM_TYPES; do      for _type in $CHECKSUM_TYPES; do
           [ -n "$NO_SIGNIFY" -a "$_type" != "${_type%.sig}" ] && continue
         if [ -e $_type ]; then          if [ -e $_type ]; then
             check_sum $_type && break              check_sum $_type && break
             [ -z "$IGNORE_CHECKSUM_ERROR" ] && exit 1              [ -z "$IGNORE_CHECKSUM_ERROR" ] && exit 1
Line 353 
Line 454 
   
   
 install_kernels() {  install_kernels() {
     echo '==> INSTALLING KERNEL'      local _d="$1"
       local boot_mount
       local mount_is_msdos
   
       if [ "$_d" ]; then
         _d=$( readlink -nf "$_d" )
       else
           mount_boot_device
   
           if [ "$KERNEL_ROOT" != "/" ]; then
                   local _ik="$INSTALL_KERNELS"
                   INSTALL_KERNELS="$BOOT_KERNEL bsd.rd"
   
                   install_kernels $KERNEL_ROOT
   
                   INSTALL_KERNELS="$_ik"
           fi
   
           umount_boot_device
   
           install_kernels /
           return
       fi
   
       echo "==> INSTALLING KERNEL to $_d"
   
     if [ X"" == X"$RELEASEDIR" ]; then      if [ X"" == X"$RELEASEDIR" ]; then
         echo ERROR: no source for new kernels! >&2          echo ERROR: no source for new kernels! >&2
         exit 1          exit 1
     fi      fi
   
       [ $_d != / ] && _d=${_d%/}/
       [ $_d != / ] && mount | grep -q " on ${_d%/} .* msdos" && mount_is_msdos=1
   
       if [ "$EFI_BOOT" -a -d /mnt/efi/boot ]; then
          echo "Copying $EFI_BOOT to /mnt/efi/boot/"
          ( cd /mnt/efi/boot \
            && cp "$RELEASEDIR/$EFI_BOOT" "n$EFI_BOOT" \
            && mv "n$EFI_BOOT" "$EFI_BOOT"
          )
       fi
   
     if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then      if [ X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
         echo "===> Backing up $BOOT_KERNEL to /obsd"          echo "===> Backing up ${_d}$BOOTED_KERNEL to ${_d}obsd"
         ln -f $BOOT_KERNEL /obsd          if [ $mount_is_msdos ]; then
               cp ${_d}$BOOTED_KERNEL ${_d}obsd
           else
               ln -f ${_d}$BOOTED_KERNEL ${_d}obsd
           fi
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
             echo "Error copying old kernel!" >&2              echo "Error copying old kernel!" >&2
             exit 1              exit 1
Line 372 
Line 512 
     cd $RELEASEDIR      cd $RELEASEDIR
   
     for _b in $INSTALL_KERNELS; do      for _b in $INSTALL_KERNELS; do
         rm -f /nbsd          rm -f ${_d}nbsd
         local _bd=$_b          local _bd=$_b
         [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"          [ X"${_b}" == X"bsd" ] && _bd="bsd.sp"
   
         local _is_boot=""          local _is_boot=""
         [ X"$BOOT_KERNEL" == X"/${_bd}" ] && _is_boot="# boot kernel"          [ X"$BOOT_KERNEL" == X"${_d}${_bd}" ] && _is_boot="# boot kernel"
   
         echo "===> Copying $_b to /$_bd $_is_boot"          echo "Copying $_b to ${_d}$_bd $_is_boot"
         cp ${_b} /nbsd && mv /nbsd /${_bd}          cp ${_b} ${_d}nbsd && mv ${_d}nbsd ${_d}${_bd}
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
             echo ERROR: Could not copy new $_bd kernel! >&2              echo ERROR: Could not copy new $_bd kernel! >&2
             exit 1              exit 1
Line 389 
Line 529 
   
     cd $OLDPWD      cd $OLDPWD
   
     if [ ! -h /bsd ]; then      if [ ! -h ${_d}bsd ]; then
             cd /          cd ${_d}
         for _b in $BOOT_KERNELS; do          for _b in $BOOT_KERNELS; do
             [ X"$_b" == X"bsd" ] && _b="bsd.sp"              [ X"$_b" == X"bsd" ] && _b="bsd.sp"
             if [ -e $_b ]; then              if [ -e $_b ]; then
                 echo "===> symlinking $_b to /bsd"                  if [ "$mount_is_msdos" ]; then
                 ln -sf $_b bsd                      echo "===> Moving $_b ${_d}bsd (MSDOS)"
                 if [ $? -ne 0 ]; then                      mv -f ${_b} bsd
                     echo ERROR: Could not symlink new kernel! >&2                  else
                     exit 1                      echo "===> symlinking $_b to ${_d}bsd"
                       ln -sf $_b bsd
                 fi                  fi
                 break                  break
             fi              fi
         done          done
             cd $OLDPWD          cd $OLDPWD
     fi      fi
 }  }
   
Line 428 
Line 569 
             _path=/var/tmp/temproot              _path=/var/tmp/temproot
         fi          fi
   
         echo "===> Extracting $_f to $_path"          echo "Extracting $_f to $_path"
         mkdir -p $_path          mkdir -p $_path
         tar -C $_path -xzphf ${RELEASEDIR}/${_f}          tar -C $_path -xzphf ${RELEASEDIR}/${_f}
         if [ $? -ne 0 ]; then          if [ $? -ne 0 ]; then
Line 468 
Line 609 
     local _v=$FILE_VER      local _v=$FILE_VER
     local _args=""      local _args=""
   
     if [ ! -e /usr/share/sysmerge/etc.tgz ]; then      if [ ! -e /var/sysmerge/etc.tgz ]; then
         if [ X"" == X"$RELEASEDIR" ]; then          if [ X"" == X"$RELEASEDIR" ]; then
             echo "ERROR: no source for etc!" >&2              echo "ERROR: no source for etc!" >&2
             exit 1              exit 1
Line 482 
Line 623 
         if [ -e xetc${_v}.tgz ]; then          if [ -e xetc${_v}.tgz ]; then
             _args="$_args -x ${RELEASEDIR}/xetc${_v}.tgz"              _args="$_args -x ${RELEASEDIR}/xetc${_v}.tgz"
         fi          fi
         if [ X"" == X"$_args" ]; then          if [ X"" == X"$_args" ]; then
             echo ERROR: No upgrade sets found! >&2              echo ERROR: No upgrade sets found! >&2
             exit 1              exit 1
         fi          fi
Line 508 
Line 649 
     . ${HOME}/.update_openbsdrc      . ${HOME}/.update_openbsdrc
 fi  fi
   
 #MIRROR=${MIRROR:=ftp://ftp.openbsd.org/pub/OpenBSD}  MIRROR=${MIRROR:=http://cdn.openbsd.org/pub/OpenBSD}
 FTP_CMD=${FTP_CMD:=ftp -V}  FTP_CMD=${FTP_CMD:=ftp -V}
 PKG_PATH=${PKG_PATH:=/usr/ports/packages/`machine`/all/:${MIRROR}/`uname -r`/packages/`machine`/}  
   
 DESTDIR=${DESTDIR:=/}  DESTDIR=${DESTDIR:=/}
 SYSMERGE=${SYSMERGE:=/usr/sbin/sysmerge}  SYSMERGE=${SYSMERGE:=/usr/sbin/sysmerge}
 FORCE_DIR=${FORCE_DIR:=No}  FORCE_DIR=${FORCE_DIR:=No}
   
   export PKG_PATH TRUSTED_PKG_PATH
   
   set_version
   
   TRUSTED_PKG_PATH=${TRUSTED_PKG_PATH:=/usr/ports/packages/`machine -a`/all}
   if [ "$FORCE_DIR" = "No" ]; then
           PKG_PATH=${PKG_PATH:=${MIRROR}/$NEW_VER/packages/`machine -a`}
   else
           PKG_PATH=${PKG_PATH:=${MIRROR}/$FORCE_DIR/packages/`machine -a`}
   fi
   
 INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}  INSTALLED_SETS=${INSTALLED_SETS:=`installed_sets`}
   
 CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256.sig SHA256}  CHECKSUM_TYPES=${CHECKSUM_TYPES:=SHA256.sig SHA256}
   
 set_version  
 local _error=$?  local _error=$?
   
 echo  echo
 echo "-= update_openbsd - helper script to update OpenBSD =-"  echo "-= update_openbsd - helper script to update OpenBSD =-"
 echo "------------------------------------------------------"  echo "------------------------------------------------------"
 echo  echo
 echo "       SYSMERGE: $SYSMERGE"  echo "        SYSMERGE: $SYSMERGE"
 echo "         MIRROR: $MIRROR"  echo "          MIRROR: $FTP"
 echo "     RELEASEDIR: $RELEASEDIR"  echo "        PKG_PATH: $PKG_PATH"
 echo "        DESTDIR: $DESTDIR"  echo "TRUSTED_PKG_PATH: $TRUSTED_PKG_PATH"
 echo "    BOOT_KERNEL: $BOOT_KERNEL"  echo "      RELEASEDIR: $RELEASEDIR"
 echo "INSTALL_KERNELS: $INSTALL_KERNELS"  echo "         DESTDIR: $DESTDIR"
 echo " INSTALLED_SETS: $INSTALLED_SETS"  echo "     BOOT_DEVICE: $BOOT_DEVICE"
   [ "$EFI_BOOT" ] && echo "        EFI_BOOT: $EFI_BOOT"
   echo "     BOOT_KERNEL: $BOOT_KERNEL"
   echo " INSTALL_KERNELS: $INSTALL_KERNELS"
   echo "  INSTALLED_SETS: $INSTALLED_SETS"
 echo  echo
 echo "        CUR_VER: $CUR_VER"  echo "         CUR_VER: $CUR_VER"
 echo "        NEW_VER: $NEW_VER"  echo "         NEW_VER: $NEW_VER"
 #echo "       FILE_VER: $FILE_VER"  #echo "        FILE_VER: $FILE_VER"
 echo  echo
   
   mount_boot_device
   l=$KERNEL_ROOT
   [ "$l" = / ] || l="$BOOT_DEVICE:"
 for k in $INSTALL_KERNELS; do  for k in $INSTALL_KERNELS; do
     if [ -e "/$k" ]; then      if [ -e $KERNEL_ROOT$k ]; then
         echo "Existing $k"          echo "Existing $l$k"
         kernel_file_version "/$k"          kernel_file_version $KERNEL_ROOT$k
     fi      fi
 done  done
   umount_boot_device
   
 if [ ${_error} -ne 0 ]; then  if [ ${_error} -ne 0 ]; then
         exit ${_error}          exit ${_error}
Line 560 
Line 718 
 echo "===> Last booted:\n$BOOTED_KERNEL_VERSION"  echo "===> Last booted:\n$BOOTED_KERNEL_VERSION"
 if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \  if [ X"$BOOT_KERNEL_VERSION" != X"$BOOTED_KERNEL_VERSION" \
   -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then    -a X"$BOOT_KERNEL_VERSION" != X"$NEW_KERNEL_VERSION" ]; then
     echo "Next boot (unless replaced):\n$BOOT_KERNEL_VERSION"      echo "Next boot $BOOTED_KERNEL (unless replaced):\n$BOOT_KERNEL_VERSION"
 fi  fi
 if [ -n "$NEW_KERNEL_VERSION" ]; then  if [ -n "$NEW_KERNEL_VERSION" ]; then
     echo "===> New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";      echo "===> New $BOOT_KERNEL:\n$NEW_KERNEL_VERSION";
Line 576 
Line 734 
     echo >&2      echo >&2
     echo "!!!  You are upgrading the OpenBSD kernel.        !!!" >&2      echo "!!!  You are upgrading the OpenBSD kernel.        !!!" >&2
     echo "!!!  You will be given the opportunity to reboot  !!!" >&2      echo "!!!  You will be given the opportunity to reboot  !!!" >&2
     echo "!!!  at the end of the proces but it is safer to  !!!" >&2      echo "!!!  at the end of the proces but it is safer to  !!!" >&2
     echo "!!!  have a separate root shell open.             !!!" >&2      echo "!!!  have a separate root shell open.             !!!" >&2
     echo "!!!  It is needed in order to run /sbin/oreboot.  !!!" >&2      echo "!!!  It is needed in order to run /sbin/oreboot.  !!!" >&2
     echo "!!!  sudo MAY NOT WORK after sets are extracted.  !!!" >&2      echo "!!!  doas MAY NOT WORK after sets are extracted.  !!!" >&2
     echo >&2      echo >&2
     echo "enter to continue, ctrl+C to cancel" >&2      echo "enter to continue, ctrl+C to cancel" >&2
     local _temp      local _temp
Line 607 
Line 765 
     fi      fi
     update_etc      update_etc
   
     echo '==> UPDATING PACKAGES'      OPENUP=$( which openup 2>/dev/null )
     pkg_add -ui -F update -F updatedepends      if [ -n "$OPENUP" ]; then
           echo "==> UPDATING WITH $OPENUP"
           $OPENUP
       else
           echo '==> UPDATING PACKAGES'
           pkg_add -u
       fi
   
       echo '==> UPDATING FIRMWARE'
       fw_update
   
 else  else
     echo Instructions for updating to the new version available from      [ -e /etc/rc.sysmerge ] && grep -q $SYSMERGE /etc/rc.sysmerge ||
           echo "$SYSMERGE -b" >>/etc/rc.sysmerge &&
           echo "==> RUNNING $SYSMERGE -b ON REBOOT"
   
       echo Instructions for updating to the new version available from
     if [ X"snapshots" == X"$FORCE_DIR" ]; then      if [ X"snapshots" == X"$FORCE_DIR" ]; then
         echo "  http://www.openbsd.org/faq/current.html"          echo "  http://www.openbsd.org/faq/current.html"
     else      else

Legend:
Removed from v.1.70  
changed lines
  Added in v.1.118

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>